From 904501f0fbb4c3e40c9cc2fcb00d8e4e02100c27 Mon Sep 17 00:00:00 2001
From: Carl Huang <cjhuang@codeaurora.org>
Date: Wed, 8 Jul 2020 14:30:47 +0800
Subject: [PATCH 133/134] ath11k: init hw param at earlier phase

For QCA6390, driver needs to generate firmware binary pathname and
pass it to MHI module. To generate firmware binary pathname, driver
needs to init hw_param firstly.

Tested-on: QCA6390 hw2.0 PCI WLAN.HST.1.0.1-01736-QCAHSTSWPLZ_V2_TO_X86-1

Change-Id: I5fa67e978a6cec9ea404a04a0b98aef681bcfcc0
Signed-off-by: Carl Huang <cjhuang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/core.c | 9 ++-------
 drivers/net/wireless/ath/ath11k/core.h | 1 +
 drivers/net/wireless/ath/ath11k/pci.c  | 6 ++++++
 3 files changed, 9 insertions(+), 7 deletions(-)

diff --git a/drivers/net/wireless/ath/ath11k/core.c b/drivers/net/wireless/ath/ath11k/core.c
index 276e791..c4a0436 100644
--- a/drivers/net/wireless/ath/ath11k/core.c
+++ b/drivers/net/wireless/ath/ath11k/core.c
@@ -909,7 +909,7 @@ static void ath11k_core_reset(struct work_struct *work)
 	ath11k_info(ab, "reset started\n");
 }
 
-static int ath11k_init_hw_params(struct ath11k_base *ab)
+int ath11k_init_hw_params(struct ath11k_base *ab)
 {
 	const struct ath11k_hw_params *hw_params = NULL;
 	int i;
@@ -934,6 +934,7 @@ static int ath11k_init_hw_params(struct ath11k_base *ab)
 
 	return 0;
 }
+EXPORT_SYMBOL(ath11k_init_hw_params);
 
 int ath11k_core_pre_init(struct ath11k_base *ab)
 {
@@ -989,12 +990,6 @@ int ath11k_core_init(struct ath11k_base *ab)
 	if (!ab->mhi_support)
 		ath11k_core_get_rproc_hdl(ab);
 
-	ret = ath11k_init_hw_params(ab);
-	if (ret) {
-		ath11k_err(ab, "failed to get hw params %d\n", ret);
-		return ret;
-	}
-
 	ret = ath11k_core_soc_create(ab);
 	if (ret) {
 		ath11k_err(ab, "failed to create soc core: %d\n", ret);
diff --git a/drivers/net/wireless/ath/ath11k/core.h b/drivers/net/wireless/ath/ath11k/core.h
index b568b04..574867f 100644
--- a/drivers/net/wireless/ath/ath11k/core.h
+++ b/drivers/net/wireless/ath/ath11k/core.h
@@ -920,6 +920,7 @@ u8 ath11k_core_get_hw_mac_id(struct ath11k_base *ab, int pdev_idx);
 int ath11k_core_pre_init(struct ath11k_base *ab);
 int ath11k_core_resume(struct ath11k_base *ab);
 int ath11k_core_suspend(struct ath11k_base *ab);
+int ath11k_init_hw_params(struct ath11k_base *ab);
 
 static inline const char *ath11k_scan_state_str(enum ath11k_scan_state state)
 {
diff --git a/drivers/net/wireless/ath/ath11k/pci.c b/drivers/net/wireless/ath/ath11k/pci.c
index 37ce18e..06e3c7b 100755
--- a/drivers/net/wireless/ath/ath11k/pci.c
+++ b/drivers/net/wireless/ath/ath11k/pci.c
@@ -1413,6 +1413,12 @@ static int ath11k_pci_probe(struct pci_dev *pdev,
 		goto err_pci_free_region;
 	}
 
+	ret = ath11k_init_hw_params(ab);
+	if (ret) {
+		ath11k_err(ab, "failed to get hw params %d\n", ret);
+		goto err_pci_free_region;
+	}
+
 	ret = ath11k_pci_register_mhi(ab_pci);
 	if (ret) {
 		ath11k_err(ab, "failed to register  mhi: %d\n", ret);
-- 
2.7.4

